/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#include "overworld.h"
#include "util/memory.h"
#include "assert/assert.h"

overworld_t OVERWORLD;

void overworldInit() {
  memoryZero(&OVERWORLD, sizeof(overworld_t));

  // Test
  OVERWORLD.mapWidth = 16;
  OVERWORLD.mapHeight = 16;
  assertTrue(
    OVERWORLD.mapWidth * OVERWORLD.mapHeight <= OVERWORLD_TILE_COUNT_MAX,
    "Map size exceeds tile count."
  );

  entityInit(OVERWORLD.entities + OVERWORLD.entityCount++, ENTITY_TYPE_PLAYER);
}

void overworldSceneInit() {

}

void overworldSceneDeinit() {

}

void overworldUpdate() {
  uint8_t i = 0;
  while(i < OVERWORLD.entityCount) {
    entityUpdate(OVERWORLD.entities + i++);
  }
}