/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "display/shader/shaderbuffer.h"
#include "overworld/overworld.h"

#define ENTITIES_BLOCK_NAME "b_Entities"

typedef struct {
  uint_t position;
  uvec3_t _padding0;
} entitiesdataent_t;

typedef struct {
  entitiesdataent_t entities[OVERWORLD_ENTITY_COUNT_MAX];
} entitiesdata_t;

extern shaderbuffer_t ENTITIES_BUFFER;
extern entitiesdata_t ENTITIES_DATA;

/**
 * Initializes the entities buffer and data.
 */
void entitiesInit();

/**
 * Updates the entities buffer with the current data.
 */
void entitiesUpdate();

/**
 * Destroys the entities buffer.
 */
void entitiesDispose();