/**
 * Copyright (c) 2025 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma ocne
#include "display/shader/shaderbuffer.h"
#include "overworld/overworld.h"

#define MAP_BLOCK_NAME "b_Map"
#define MAP_PACKED_SIZE 4

typedef struct {
  uint32_t nothing;
  uvec3_t _padding0;
} maptiledata_t;

typedef struct {
  uint_t mapSize;
  uvec3_t _padding0;

  uint32_t tileIds[OVERWORLD_TILE_COUNT_MAX / MAP_PACKED_SIZE];
  maptiledata_t tileData[OVERWORLD_TILE_COUNT_MAX];
} mapdata_t;

extern shaderbuffer_t MAP_BUFFER;
extern mapdata_t MAP_DATA;

/**
 * Initializes the map buffer and data.
 */
void mapInit();

/**
 * Updates the map buffer with the current data.
 */
void mapUpdate();

/**
 * Destroys the map buffer.
 */
void mapDispose();